<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xf="http://www.w3.org/2002/xforms"
	xmlns:xsd="http://www.w3.org/2001/XMLSchema"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<xsl:output method="xml" version="1.0" encoding="iso-8859-1" indent="yes"/>
	<!--_________________________________________________________________________________________________________STRUCTURE DU DOCUMENT _______________________________ -->
	<!--	xmlns="http://www.w3.org/2002/06/xhtml2" 	____-->
	<xsl:template match="/">
		<html>
			<head>
				<title>Prototype</title>
				<style type="text/css">
					.element_terminal {background-color : #ddddff;}
					.element_non_terminal {background-color : #9999dd;}
					.attribut {background-color : #ddfdde;}
					.bouton_masque_arborescence {margin-right:1.5:mm;}
				</style>
				<xf:model id="model">
					<xf:instance id="instance">
					</xf:instance>
					<xf:submission method="put" includenamespaceprefixes="" action="mc_output.xml" id="bValider" replace="none"/>
				</xf:model>
				<script type="text/javascript">
					
					// 
					function change_visiblity(id_bouton_masque, id_bloc_fils)
					{
						bloc_fils=document.getElementById(id_bloc_fils);
						bouton_masque=document.getElementById(id_bouton_masque);
						if (bloc_fils.style.display=='none')
						{
							bloc_fils.style.display='';
							bouton_masque.innerHTML="-";
						} 
						else
						{
							bloc_fils.style.display='none';
							bouton_masque.innerHTML="+";
						}
					}
				</script>
			</head>
			<body>
				<h2>Form</h2>
				<xsl:apply-templates/>
				<table align="center">
					<tr>
						<td align="center">
							<xf:submit submission="bValider">
								<xf:label>Valider les modifications</xf:label>
							</xf:submit>
						</td>
					</tr>
					<tr align="center">
						<td align="center">
							Message Center component for JIAP 1.0
						</td>
					</tr>
				</table>
			</body>
		</html>
	</xsl:template>
	<!--__________________________________________________________________________________________________________ GESTION DES ATTRIBUTS______________________________ -->
	<xsl:template name="gestion_attributs">
		<xsl:param name="param_id"/>
		<xsl:if test="count(attribute::*)!=0">
			<tr id="{$param_id}">
				<td colspan="2">
					<table style="width:100%" border="0">
						<xsl:for-each select="attribute::*">
							<tr>
								<td class="attribut" width="50%">
									<xsl:value-of select="name(current())"/>
								</td>
								<td>
									<xf:input style="width:100%">
										<xsl:attribute name="ref"><xsl:for-each select="ancestor::*"><xsl:text>/*[</xsl:text><xsl:value-of select="1+count(preceding-sibling::*)"/><xsl:text>]</xsl:text></xsl:for-each><xsl:text>/@</xsl:text><xsl:value-of select="name(current())"/></xsl:attribute>
									</xf:input>
								</td>
							</tr>
						</xsl:for-each>
					</table>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>
	<!--_________________________________________________________________________________________________________CREATION D'UN ELEMENT DE LA TABLE_________________ -->
	<xsl:template match="*">
		<xsl:variable name="id" select="generate-id()"/>
		<table border="0" style="width:100%">
			<xsl:choose>
				<!-- _____________________________________________________ CAS D'UN ELEMENT TERMINAL_______________-->
				<xsl:when test="count(child::*) = 0">
					<tr>
						<xsl:if test="count(attribute::*)>0">
							<xsl:attribute name="onclick">
								change_visiblity('<xsl:value-of select="$id"/>_bouton_masque', '<xsl:value-of select="$id"/>');
								</xsl:attribute>
							<xsl:attribute name="style">cursor:pointer</xsl:attribute>
						</xsl:if>
						<td class="element_terminal" width="50%">
							<!-- l'élément terminal possède des attributs : on ajoute un moyen pour les cacher -->
							<xsl:if test="count(attribute::*)>0">
								<span class="bouton_masque_arborescence" id="{$id}_bouton_masque">-</span>
							</xsl:if>
							<xsl:value-of select="name(current())"/>
						</td>
						<td>
							<xf:input style="width:100%">
								<xsl:attribute name="ref"><xsl:for-each select="ancestor-or-self::*"><xsl:text>/*[</xsl:text><xsl:value-of select="1+count(preceding-sibling::*)"/><xsl:text>]</xsl:text></xsl:for-each></xsl:attribute>
							</xf:input>
						</td>
					</tr>
					<xsl:call-template name="gestion_attributs">
						<xsl:with-param name="param_id" select="$id"/>
					</xsl:call-template>
				</xsl:when>
				<!--_____________________________________________________ CAS D'UN NOEUD___________________________ -->
				<xsl:otherwise>
					<tr>
						<td>
							<table style="width:100%" border="0">
								<tr>
									<xsl:if test="(count(child::*)+count(attribute::*))>0">
										<xsl:attribute name="onclick">
											change_visiblity('<xsl:value-of select="$id"/>_bouton_masque', '<xsl:value-of select="$id"/>');
										</xsl:attribute>
										<xsl:attribute name="style">cursor:pointer</xsl:attribute>
									</xsl:if>
									<td class="element_non_terminal">
										<xsl:if test="(count(child::*)+count(attribute::*))>0">
											<span class="bouton_masque_arborescence" id="{$id}_bouton_masque">-</span>
										</xsl:if>
										<xsl:value-of select="name(current())"/>
									</td>
								</tr>
								<tr id="{$id}">
									<td>
										<table style="width:100%">
											<xsl:call-template name="gestion_attributs">
												<xsl:with-param name="param_id" select="$id"/>
											</xsl:call-template>
											<tr>
												<td>
													<xsl:apply-templates/>
												</td>
											</tr>
										</table>
									</td>
								</tr>
							</table>
						</td>
					</tr>
				</xsl:otherwise>
			</xsl:choose>
		</table>
	</xsl:template>
</xsl:stylesheet>
