/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: PropertiesGroupMembers.java,v 1.1 2004/07/30 14:57:57 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.mapper;

import hero.util.HeroException;
import hero.interfaces.BnRoleLocal;

// use of the ProjectSession Bean
import hero.interfaces.ProjectSessionLocalHome;
import hero.interfaces.ProjectSessionLocal;
import hero.interfaces.ProjectSessionUtil;

import javax.ejb.SessionContext;

import java.util.*;


public class PropertiesGroupMembers implements hero.mapper.RoleMapperI {

    public void searchMembers(Object b,BnRoleLocal n, String userName) throws HeroException {	
	    
	    String roleName=n.getName();
	    String projectName=n.getBnProject().getName();	    
	    
		try {
			ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)ProjectSessionUtil.getLocalHome();
			ProjectSessionLocal projectsession = projecth.create();
			projectsession.initProject(projectName);				
			
			// logs trace
			System.out.println("[PropertiesGroupMembers] instanceCreator : " + userName + " BnRole name: " + roleName + " - Project name = " + projectName);

			// add user to the project instance: not useful because the authenticated user is already defined within the project
			// projectsession.addUser(userName);
				
			// set the user role
			projectsession.setUserRole(userName, roleName);
			
			// logs trace
			System.out.println("Set role: " + roleName + " to user: " + userName );
			
			projectsession.remove();		
		
		} catch (Exception e) {		    
			throw new HeroException("Error setting role : " + roleName + " with properties mapper " + e.getMessage());
		}				    
    } 

}















